#include <iostream>
#include <vector>
#include <cmath>
#include <numeric>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    vector<int> dcnt(10, 0);
    for (int d=0; d<10; ++d) cin >> dcnt[d];
    ll x = 2;
    for (int i=2; i<=10; ++i) {
        vector<int> dc(10,0);
        for (ll y=x; y>0; y/=10) ++dc[y%10];
        if (dc == dcnt) {
            cout << i << endl;
            return 0;
        }
        x = 1ll*(i+1)*x;
    }
    long double y = log10(2.0l);
    long double s = accumulate(dcnt.begin(), dcnt.end(), 0.0l);
    long double ans = 2.0l;
    while (y + 1e-8 < s) {
        ans += 1.0l;
        y += log10(ans);
    }
    cout << ans-1 << endl;

    return 0;
}
